//************************************************************************
// Program Name	: Basic Functions that read  and print Various Types of Data
// Programmer	: Petros Panayi	Stud. ID: 000000
// Date  Modif.	: 1 Sep 2017
//************************************************************************
// Comments: Basic Functions that read  and print Various Types of Data
// Stack Frame:
//				|-----------------------|
//	  			|						|
//		sp'-->	|-----------------------|
//	  			|					|
//				|-----------------------|<-- fp(x29) + 28
//	  			|						|
//				|-----------------------|
//	  			|						|
//				|-----------------------|<-- fp(x29) + 24
//	  			|						|
//				|-----------------------|
//	  			|	 *** x30 = lr'	***	|
//				|-----------------------|
//	  			|	*** x30 = lr'	***	|
//				|-----------------------|<-- fp(x29) + 8
//	  			|		X29 = fp'		|
//				|-----------------------|
//	  			|		X29 = fp'		|
//sp=sp'-32 -->	|-----------------------| <-- fp(x29)
//	  			|						|
//				|-----------------------|
//	  			|						|
//				|-----------------------|
//	  			|						|
//				|-----------------------|
//	  			|						|
//************************************************************************
.data
my_Table:			.space  512			// Defining space for 512Bytes/128Words
size:				.word	128			// The size of the table is 128
out_message_str: 	.string	"%d "

//************************************************************************	
	.text
	.global	main
main:

	stp	X29, X30, [sp, -32]!	//	First (!) move the stack pointer 32 bytes down (sp-32)
								//  and then store double x29 and x30 which is the Link Register (S.O.S). 
								// (pre-index modes whih means apply the offset before accessing the memory)
	add	x29, sp, 0				//	Copy the value of stack pointer to Frame Pointer
	
	ldr		w1, size			// There are 128 Integer in the table				
	adr		x0, my_Table
	bl 		initTable
	
	ldr		w1, size			// There are 128 Integer in the table
	adr		x0, my_Table
	bl 		printTable
	
	ldp	x29, x30, [sp], 32		// Release the stack space
	ret							// Return to loading function

	
//************************************************************************
//**************************************************************************
initTable:
	stp		X29, X30, [sp, -32]!	
	add		x29, sp, 0				
	
	mov 	x2, xzr 
loop_init:
	str		w2,	[x0], 4
	add		w2, w2, 1
	add		w1,w1, -1
	cbnz	w1, loop_init
	

	ldp		x29, x30, [sp], 32
	ret
//**************************************************************************************
printTable:
	stp		X29, X30, [sp, -32]!	
	add		x29, sp, 0	

	str		x19, [sp, 24]
	str		x20, [sp, 28]
	
	mov 	x19, x0
	mov		x20, x1
	adr		x0, out_message_str
loop_print:
	adr		x0, out_message_str
	ldr		w1,	[x19], 4
	bl 		printf
	add		x20,x20, -1
	cbnz	x20, loop_print

	ldr		x19, [sp, 24]
	ldr		x20, [sp, 28]
	
	ldp		x29, x30, [sp], 32
	ret
//**************************************************************************************
